Index: /trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMInformationDlg.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMInformationDlg.cpp	(revision 47997)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMInformationDlg.cpp	(revision 47998)
@@ -116,5 +116,5 @@
     connect (pMachineWindow->machineView(), SIGNAL (resizeHintDone()), this, SLOT (processStatistics()));
     connect (mInfoStack, SIGNAL (currentChanged (int)), this, SLOT (onPageChanged (int)));
-    connect (&vboxGlobal(), SIGNAL (mediumEnumFinished (const VBoxMediaList &)), this, SLOT (updateDetails()));
+    connect(&vboxGlobal(), SIGNAL(sigMediumEnumerationFinished(const VBoxMediaList&)), this, SLOT(updateDetails()));
     connect (mStatTimer, SIGNAL (timeout()), this, SLOT (processStatistics()));
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxGlobal.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxGlobal.cpp	(revision 47997)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxGlobal.cpp	(revision 47998)
@@ -1799,7 +1799,7 @@
     AssertReturnVoid(m_pMediumEnumerationThread);
 
-    /* Emit mediumEnumStarted() after we set m_pMediumEnumerationThread to != NULL
+    /* Emit signal *after* we set m_pMediumEnumerationThread to != NULL
      * to cause isMediaEnumerationStarted() to return TRUE from slots: */
-    emit mediumEnumStarted();
+    emit sigMediumEnumerationStarted();
 
     m_pMediumEnumerationThread->start();
@@ -4035,5 +4035,5 @@
                 Assert (ev->mIterator != m_mediums.end());
                 *(ev->mIterator) = ev->mMedium;
-                emit mediumEnumerated (*ev->mIterator);
+                emit sigMediumEnumerated(*ev->mIterator);
             }
             else
@@ -4043,5 +4043,5 @@
                 delete m_pMediumEnumerationThread;
                 m_pMediumEnumerationThread = 0;
-                emit mediumEnumFinished (m_mediums);
+                emit sigMediumEnumerationFinished(m_mediums);
             }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxGlobal.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxGlobal.h	(revision 47997)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxGlobal.h	(revision 47998)
@@ -385,7 +385,7 @@
 
     /* Notifiers: Medium-enumeration stuff: */
-    void mediumEnumStarted();
-    void mediumEnumerated(const UIMedium &medum);
-    void mediumEnumFinished(const VBoxMediaList &mediums);
+    void sigMediumEnumerationStarted();
+    void sigMediumEnumerated(const UIMedium &medium);
+    void sigMediumEnumerationFinished(const VBoxMediaList &mediums);
 
     /** Emitted when a new media is added using #addMedia(). */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.cpp	(revision 47997)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.cpp	(revision 47998)
@@ -490,13 +490,11 @@
     mButtonBox->button (QDialogButtonBox::Cancel)->setVisible (mDoSelect);
 
-    /* Listen to "media enumeration started" signals */
-    connect (&vboxGlobal(), SIGNAL (mediumEnumStarted()),
-             this, SLOT (mediumEnumStarted()));
-    /* Listen to "media enumeration" signals */
-    connect (&vboxGlobal(), SIGNAL (mediumEnumerated (const UIMedium &)),
-             this, SLOT (mediumEnumerated (const UIMedium &)));
-    /* Listen to "media enumeration finished" signals */
-    connect (&vboxGlobal(), SIGNAL (mediumEnumFinished (const VBoxMediaList &)),
-             this, SLOT (mediumEnumFinished (const VBoxMediaList &)));
+    /* Configure medium-enumeration connections: */
+    connect(&vboxGlobal(), SIGNAL(sigMediumEnumerationStarted()),
+            this, SLOT(sltHandleMediumEnumerationStart()));
+    connect(&vboxGlobal(), SIGNAL(sigMediumEnumerated(const UIMedium&)),
+            this, SLOT(sltHandleMediumEnumerated(const UIMedium&)));
+    connect(&vboxGlobal(), SIGNAL(sigMediumEnumerationFinished(const VBoxMediaList&)),
+            this, SLOT(sltHandleMediumEnumerationFinish(const VBoxMediaList&)));
 
     /* Listen to "media add" signals */
@@ -528,5 +526,5 @@
         /* Emulate the finished signal to reuse the code */
         if (!vboxGlobal().isMediaEnumerationStarted())
-            mediumEnumFinished (list);
+            sltHandleMediumEnumerationFinish(list);
     }
 
@@ -967,5 +965,5 @@
 }
 
-void UIMediumManager::mediumEnumStarted()
+void UIMediumManager::sltHandleMediumEnumerationStart()
 {
     /* Reset inaccessible flags */
@@ -1001,5 +999,5 @@
 }
 
-void UIMediumManager::mediumEnumerated (const UIMedium &aMedium)
+void UIMediumManager::sltHandleMediumEnumerated(const UIMedium &aMedium)
 {
     mediumUpdated (aMedium);
@@ -1008,5 +1006,5 @@
 }
 
-void UIMediumManager::mediumEnumFinished (const VBoxMediaList &/* aList */)
+void UIMediumManager::sltHandleMediumEnumerationFinish(const VBoxMediaList &/* aList */)
 {
     mProgressBar->setVisible (false);
Index: /trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.h	(revision 47997)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.h	(revision 47998)
@@ -81,7 +81,7 @@
     void mediumRemoved (UIMediumType aType, const QString &aId);
 
-    void mediumEnumStarted();
-    void mediumEnumerated (const UIMedium &aMedium);
-    void mediumEnumFinished (const VBoxMediaList &aList);
+    void sltHandleMediumEnumerationStart();
+    void sltHandleMediumEnumerated(const UIMedium &aMedium);
+    void sltHandleMediumEnumerationFinish(const VBoxMediaList &aList);
 
     void doNewMedium();
Index: /trunk/src/VBox/Frontends/VirtualBox/src/selector/UISelectorWindow.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/selector/UISelectorWindow.cpp	(revision 47997)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/selector/UISelectorWindow.cpp	(revision 47998)
@@ -177,5 +177,5 @@
 }
 
-void UISelectorWindow::sltMediumEnumFinished()
+void UISelectorWindow::sltHandleMediumEnumerationFinish()
 {
     /* We try to warn about inaccessible mediums only once
@@ -1036,5 +1036,5 @@
     /* Make sure user warned about inaccessible medium(s)
      * even if enumeration had finished before selector window shown: */
-    QTimer::singleShot(0, this, SLOT(sltMediumEnumFinished()));
+    QTimer::singleShot(0, this, SLOT(sltHandleMediumEnumerationFinish()));
 }
 
@@ -1403,5 +1403,5 @@
 {
     /* Medium enumeration connections: */
-    connect(&vboxGlobal(), SIGNAL(mediumEnumFinished(const VBoxMediaList &)), this, SLOT(sltMediumEnumFinished()));
+    connect(&vboxGlobal(), SIGNAL(sigMediumEnumerationFinished(const VBoxMediaList &)), this, SLOT(sltHandleMediumEnumerationFinish()));
 
     /* Menu-bar connections: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/selector/UISelectorWindow.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/selector/UISelectorWindow.h	(revision 47997)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/selector/UISelectorWindow.h	(revision 47998)
@@ -65,5 +65,5 @@
 
     /* Handler: Medium enumeration stuff: */
-    void sltMediumEnumFinished();
+    void sltHandleMediumEnumerationFinish();
 
     /* Handler: Menubar/status stuff: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/details/UIGDetailsSet.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/details/UIGDetailsSet.cpp	(revision 47997)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/details/UIGDetailsSet.cpp	(revision 47998)
@@ -346,6 +346,6 @@
 
     /* Meidum-enumeration connections: */
-    connect(&vboxGlobal(), SIGNAL(mediumEnumStarted()), this, SLOT(sltUpdateAppearance()));
-    connect(&vboxGlobal(), SIGNAL(mediumEnumFinished(const VBoxMediaList &)), this, SLOT(sltUpdateAppearance()));
+    connect(&vboxGlobal(), SIGNAL(sigMediumEnumerationStarted()), this, SLOT(sltUpdateAppearance()));
+    connect(&vboxGlobal(), SIGNAL(sigMediumEnumerationFinished(const VBoxMediaList &)), this, SLOT(sltUpdateAppearance()));
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsDialogSpecific.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsDialogSpecific.cpp	(revision 47997)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsDialogSpecific.cpp	(revision 47998)
@@ -553,5 +553,5 @@
 
     /* Allow to reset first-run flag just when medium enumeration was finished: */
-    connect(&vboxGlobal(), SIGNAL(mediumEnumFinished(const VBoxMediaList &)), this, SLOT(sltAllowResetFirstRunFlag()));
+    connect(&vboxGlobal(), SIGNAL(sigMediumEnumerationFinished(const VBoxMediaList &)), this, SLOT(sltAllowResetFirstRunFlag()));
 
     /* Get corresponding machine (required to determine dialog type and page availability): */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsStorage.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsStorage.cpp	(revision 47997)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsStorage.cpp	(revision 47998)
@@ -1831,10 +1831,10 @@
 
     /* Setup connections */
-    connect (&vboxGlobal(), SIGNAL (mediumEnumerated (const UIMedium &)),
-             this, SLOT (mediumUpdated (const UIMedium &)));
+    connect (&vboxGlobal(), SIGNAL (sigMediumEnumerated (const UIMedium &)),
+             this, SLOT (sltHandleMediumUpdated (const UIMedium &)));
     connect (&vboxGlobal(), SIGNAL (mediumUpdated (const UIMedium &)),
-             this, SLOT (mediumUpdated (const UIMedium &)));
+             this, SLOT (sltHandleMediumUpdated (const UIMedium &)));
     connect (&vboxGlobal(), SIGNAL (mediumRemoved (UIMediumType, const QString &)),
-             this, SLOT (mediumRemoved (UIMediumType, const QString &)));
+             this, SLOT (sltHandleMediumRemoved (UIMediumType, const QString &)));
     connect (mAddCtrAction, SIGNAL (triggered (bool)), this, SLOT (addController()));
     connect (mAddIDECtrAction, SIGNAL (triggered (bool)), this, SLOT (addIDEController()));
@@ -2271,5 +2271,5 @@
 }
 
-void UIMachineSettingsStorage::mediumUpdated (const UIMedium &aMedium)
+void UIMachineSettingsStorage::sltHandleMediumUpdated(const UIMedium &aMedium)
 {
     QModelIndex rootIndex = mStorageModel->root();
@@ -2292,5 +2292,5 @@
 }
 
-void UIMachineSettingsStorage::mediumRemoved (UIMediumType /* aType */, const QString &aMediumId)
+void UIMachineSettingsStorage::sltHandleMediumRemoved(UIMediumType /* aType */, const QString &aMediumId)
 {
     QModelIndex rootIndex = mStorageModel->root();
Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsStorage.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsStorage.h	(revision 47997)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsStorage.h	(revision 47998)
@@ -682,6 +682,6 @@
 private slots:
 
-    void mediumUpdated (const UIMedium &aMedium);
-    void mediumRemoved (UIMediumType aType, const QString &aMediumId);
+    void sltHandleMediumUpdated(const UIMedium &aMedium);
+    void sltHandleMediumRemoved(UIMediumType aType, const QString &aMediumId);
 
     void addController();
Index: /trunk/src/VBox/Frontends/VirtualBox/src/widgets/VBoxMediaComboBox.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/widgets/VBoxMediaComboBox.cpp	(revision 47997)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/widgets/VBoxMediaComboBox.cpp	(revision 47998)
@@ -38,9 +38,9 @@
     setSizePolicy (sp1);
 
-    /* Setup enumeration handlers */
-    connect (&vboxGlobal(), SIGNAL (mediumEnumStarted()),
-             this, SLOT (mediumEnumStarted()));
-    connect (&vboxGlobal(), SIGNAL (mediumEnumerated (const UIMedium &)),
-             this, SLOT (mediumEnumerated (const UIMedium &)));
+    /* Setup medium-enumeration handlers: */
+    connect(&vboxGlobal(), SIGNAL(sigMediumEnumerationStarted()),
+            this, SLOT(sltHandleMediumEnumerationStart()));
+    connect(&vboxGlobal(), SIGNAL(sigMediumEnumerated (const UIMedium&)),
+            this, SLOT(sltHandleMediumEnumerated(const UIMedium&)));
 
     /* Setup update handlers */
@@ -168,10 +168,10 @@
 
 
-void VBoxMediaComboBox::mediumEnumStarted()
+void VBoxMediaComboBox::sltHandleMediumEnumerationStart()
 {
     refresh();
 }
 
-void VBoxMediaComboBox::mediumEnumerated (const UIMedium &aMedium)
+void VBoxMediaComboBox::sltHandleMediumEnumerated(const UIMedium &aMedium)
 {
     mediumUpdated (aMedium);
Index: /trunk/src/VBox/Frontends/VirtualBox/src/widgets/VBoxMediaComboBox.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/widgets/VBoxMediaComboBox.h	(revision 47997)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/widgets/VBoxMediaComboBox.h	(revision 47998)
@@ -52,6 +52,6 @@
 protected slots:
 
-    void mediumEnumStarted();
-    void mediumEnumerated (const UIMedium &);
+    void sltHandleMediumEnumerationStart();
+    void sltHandleMediumEnumerated(const UIMedium &);
 
     void mediumAdded (const UIMedium &);